Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-1.5-compat
%define version 2.0.7
%define name maven2-bootstrap
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define maven_version   2.0.7
%define RHEL4 0
%define NONFREE 0

%define base_name maven

%define repo_dir m2_home_local/repository
%define maven_settings_file %{_builddir}/%{name}/settings.xml

Name:           %{base_name}2-bootstrap
Version:        %{maven_version}
Release:        alt3_3jpp5
Epoch:          0
Summary:        Java project management and project comprehension tool.

Group:          Development/Java
License:        Apache Software License 2.0
URL:            http://maven.apache.org/

# svn export http://svn.apache.org/repos/asf/maven/components/tags/maven-2.0.7 maven2
Source0:        %{base_name}2-2.0.7-src.tar.gz

Source1:        m2b_pom_repo.tar.gz

Source2:        maven2-JPackageRepositoryLayout.java
Source3:        maven2-settings.xml

Source4:        %{base_name}2-model-v3.tar.gz
Source5:        %{base_name}2-MavenJPackageDepmap.java
Source6:        %{base_name}2-addjdom-depmap.xml
Source7:        %{base_name}2-empty-dep.pom
Source8:        %{base_name}2-empty-dep.jar

Patch1:         %{base_name}2-addjdomtobootstrappath.patch
Patch2:         %{base_name}2-jpprepolayout.patch
Patch3:        maven2-core-bootstrap-pom.patch
Patch4:        maven2-bootstrap-nomodello.patch
Patch5:        maven2-bootstrap-noinstaller.patch

BuildRequires: jpackage-utils >= 0:1.7.3
BuildRequires: /bin/ls /usr/bin/head /usr/bin/find /usr/bin/awk /bin/grep /bin/sed

BuildRequires: ant >= 0:1.6.5
BuildRequires: bsh >= 0:1.3.0
BuildRequires: classworlds >= 0:1.1
BuildRequires: easymock >= 0:1.2
BuildRequires: jakarta-commons-cli >= 0:1.0
BuildRequires: jdom >= 0:1.0
BuildRequires: jsch >= 0:0.1.20
BuildRequires: jtidy >= 0:1.0
BuildRequires: junit >= 0:3.8.2
BuildRequires: maven2-common-poms >= 0:1.0-3
BuildRequires: maven-doxia >= 0:1.0-0.a10
BuildRequires: maven-wagon >= 0:1.0
BuildRequires: modello >= 0:1.0-0.a15
BuildRequires: plexus-ant-factory >= 0:1.0-0.a1.2
BuildRequires: plexus-bsh-factory >= 0:1.0-0.a7s.2
BuildRequires: plexus-container-default >= 0:1.0-0.a9s1
BuildRequires: plexus-interactivity >= 0:1.0
BuildRequires: plexus-utils >= 0:1.4.5
BuildRequires: xml-commons-jaxp-1.3-apis

BuildRequires: saxon-scripts >= 0:6.5.3

Requires: ant >= 0:1.6.5
Requires: bsh >= 0:1.3.0
Requires: classworlds >= 0:1.1
Requires: jakarta-commons-cli >= 0:1.0
Requires: jdom >= 0:1.0
Requires: jsch >= 0:0.1.20
Requires: jtidy >= 0:1.0
Requires: junit >= 0:3.8.2
Requires: maven2-common-poms >= 0:1.0-3
Requires: maven-doxia >= 0:1.0-0.a10
Requires: maven-wagon >= 0:1.0
Requires: plexus-ant-factory >= 0:1.0-0.a1.2
Requires: plexus-bsh-factory >= 0:1.0-0.a7s.2
Requires: plexus-container-default >= 0:1.0-0.a9s1
Requires: plexus-interactivity >= 0:1.0
Requires: plexus-utils >= 0:1.4.5
Requires: xalan-j2 >= 0:2.7.0
Requires: xml-commons-jaxp-1.3-apis

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3 /bin/rmdir


BuildArch:      noarch

%description
Maven is a software project management and comprehension tool. Based on the 
concept of a project object model (POM), Maven can manage a project's build,
reporting and documentation from a central piece of information.


%prep
%setup -q -c -n %{name}

# Remove existing binaries from source trees
#find . -name "*.jar" -exec rm -f '{}' \;

%patch1 -b .sav1
%patch2 -b .sav2


# extract poms and jars (if any)
tar xzf %{SOURCE1}

%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5

# Extract model-v3
tar xzf %{SOURCE4}

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

cp %{SOURCE2} maven2/maven-artifact/src/main/java/org/apache/maven/artifact/repository/layout/JPackageRepositoryLayout.java
cp %{SOURCE5} maven2/maven-artifact/src/main/java/org/apache/maven/artifact/repository/layout/MavenJPackageDepmap.java

# FIXME: bootstrap-mini has no dependencies, so we copy the file there 
# (for now). Since bootstrap classes are not in the final package, there 
# will be no duplicates.
mkdir -p maven2/bootstrap/bootstrap-mini/src/main/java/org/apache/maven/artifact/repository/layout/
cp %{SOURCE5} maven2/bootstrap/bootstrap-mini/src/main/java/org/apache/maven/artifact/repository/layout/MavenJPackageDepmap.java

cp %{SOURCE3} %{maven_settings_file}
sed -i -e "s|<url>__INTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" %{maven_settings_file}

sed -i -e "s|<url>__EXTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" %{maven_settings_file}

sed -i -e "s|__INTERNAL_REPO_PLACEHOLDER__|file://`pwd`/m2_repo/repository|g" maven2/bootstrap/bootstrap-mini/src/main/java/org/apache/maven/bootstrap/download/OnlineArtifactDownloader.java

sed -i -e "s|__EXTERNAL_REPO_PLACEHOLDER__|file://`pwd`/external_repo|g" maven2/bootstrap/bootstrap-mini/src/main/java/org/apache/maven/bootstrap/download/OnlineArtifactDownloader.java

# Copy the empty dependency jar/pom in place
mkdir -p m2_repo/repository/JPP/maven2/default_poms
cp %{SOURCE7} m2_repo/repository/JPP/maven2/default_poms/JPP.maven2-empty-dep.pom
cp %{SOURCE8} m2_repo/repository/JPP/maven2/empty-dep.jar

for i in $(find . -name "*.java" -exec grep -l "org\.codehaus\.doxia\." {} \;); do
        sed -i -e s:org.codehaus.doxia.sink.Sink:org.apache.maven.doxia.sink.Sink:g $i
        sed -i -e s:org.codehaus.doxia.site.renderer.SiteRenderer:org.apache.maven.doxia.siterenderer.Renderer:g $i
        sed -i -r -e s:\(\\s+\)SiteRenderer\(\\s+\):\\1Renderer\\2:g $i
done


%build
export JAVA_HOME=%{_jvmdir}/java-1.5.0
# Wire in jdom dependency
cp maven2/maven-artifact/pom.xml maven2/maven-artifact/pom.xml.withoutjdom
saxon -o maven2/maven-artifact/pom.xml maven2/maven-artifact/pom.xml.withoutjdom /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE6}

cp maven2/bootstrap/bootstrap-installer/pom.xml maven2/bootstrap/bootstrap-installer/pom.xml.withoutjdom
saxon -o maven2/bootstrap/bootstrap-installer/pom.xml maven2/bootstrap/bootstrap-installer/pom.xml.withoutjdom /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE6}

export CLASSPATH=$(build-classpath \
classworlds \
modello/core \
modello/plugin-xml \
modello/plugin-xpp3 \
modello/plugin-xsd \
plexus/classworlds \
plexus/containers-component-api \
plexus/containers-container-default \
plexus/utils \
)

pushd maven2/maven-repository-metadata
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/metadata.mdo java src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/metadata.mdo xpp3-reader src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/metadata.mdo xpp3-writer src/main/java 1.0.0 false
popd
pushd maven2/maven-model
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo java src/main/java 4.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xpp3-reader src/main/java 4.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xpp3-writer src/main/java 4.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xpp3-writer src/main/java 3.0.0 true
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo java src/main/java 3.0.0 true
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xpp3-reader src/main/java 3.0.0 true
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/maven.mdo xsd src/main/java 3.0.0 true
popd
pushd maven2/maven-settings
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/settings.mdo java src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/settings.mdo xpp3-reader src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/settings.mdo xpp3-writer src/main/java 1.0.0 false
popd
pushd maven2/maven-profile
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli profiles.mdo java src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli profiles.mdo xpp3-reader src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli profiles.mdo xpp3-writer src/main/java 1.0.0 false
popd
pushd maven2/maven-plugin-registry
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli plugin-registry.mdo java src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli plugin-registry.mdo xpp3-reader src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli plugin-registry.mdo xpp3-writer src/main/java 1.0.0 false
popd
pushd maven2/maven-plugin-descriptor
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/lifecycle.mdo java src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/lifecycle.mdo xpp3-reader src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/lifecycle.mdo xpp3-writer src/main/java 1.0.0 false
popd
pushd maven2/maven-plugin-parameter-documenter
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/paramdoc.mdo java src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/paramdoc.mdo xpp3-reader src/main/java 1.0.0 false
$JAVA_HOME/bin/java org.codehaus.modello.ModelloCli src/main/mdo/paramdoc.mdo xpp3-writer src/main/java 1.0.0 false
popd

# Build maven2
export MAVEN_REPO_LOCAL=`pwd`/%{repo_dir}
export M2_SETTINGS_FILE=%{maven_settings_file}

# In bootstrap mode, we want it looking at default poms only (controlled via 
# maven2-common-poms). This enables us to change naming structures without 
# breaking build.

export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.ignore.versions -Dmaven2.offline.mode -Dmaven.test.failure.ignore=true"
export M2_HOME=`pwd`/maven2/home/%{base_name}-%{version}

mkdir -p m2_home_local/repository/org/apache/maven/bootstrap/bootstrap-mini/2.0.8-SNAPSHOT
cp m2_repo/repository/JPP/maven2/default_poms/JPP.maven2-bootstrap-mini.pom \
m2_home_local/repository/org/apache/maven/bootstrap/bootstrap-mini/2.0.8-SNAPSHOT/bootstrap-mini-2.0.8-SNAPSHOT.pom

mkdir -p m2_repo/repository/easymock
ln -sf $(build-classpath easymock) m2_repo/repository/easymock/easymock.jar

# pushd maven2/ ...
pushd %{base_name}2 >& /dev/null

[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java-1.4.2
export JAVA_HOME

mkdir bootstrap/lib
ln -s $(build-classpath jdom) bootstrap/lib/jdom.jar
export CLASSPATH=`pwd`/bootstrap/lib/jdom.jar
export JDOMCLASS=$CLASSPATH
./bootstrap.sh --prefix=`pwd`/home  --settings=%{maven_settings_file}
unset CLASSPATH

popd >& /dev/null

%install

# Repository
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/repository

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/lib

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/core/boot

install -pm 644 %{base_name}2/maven-reporting/maven-reporting-api/target/maven-reporting-api.jar \
                 $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/lib/maven-reporting-api-%{version}.jar

for library in maven-artifact \
               maven-artifact-manager\
               maven-core \
               maven-error-diagnostics \
               maven-model \
               maven-monitor \
               maven-plugin-api \
               maven-plugin-descriptor \
               maven-plugin-parameter-documenter \
               maven-plugin-registry \
               maven-profile \
               maven-project \
               maven-repository-metadata \
               maven-settings; do

     install -pm 644 %{base_name}2/${library}/target/${library}.jar \
       $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/lib/${library}-%{version}.jar
done

# Also, link maven jars from /usr/share/java
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{base_name}2
for library in $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/lib/*-%{version}.jar; do
    ln -s %{_datadir}/%{base_name}2/lib/`basename $library` $RPM_BUILD_ROOT%{_javadir}/%{base_name}2/`basename $library | sed -e s:^maven-::g`
done

# Some things are not in lib/ by default, and we don't want them there
# either, otherwise the maven classloader loads them and weird things
# happen... but there is no harm in putting in javadir/maven2

#rap#for project in maven-archiver maven-artifact-test maven-model-converter; do
for project in maven-artifact-test; do
    installname=`echo $project | sed -e s:^maven-::g`
    install -pm 644 %{base_name}2/$project/target/$project.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}2/$installname-%{version}.jar
done

install -pm 644 %{base_name}2/maven-script/maven-script-ant/target/maven-script-ant.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}2/script-ant-%{version}.jar
install -pm 644 %{base_name}2/maven-script/maven-script-beanshell/target/maven-script-beanshell.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}2/script-beanshell-%{version}.jar

# Create versionless symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{base_name}2 && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar | sed  "s|-%{version}||g"`; done)

# For backwards compatibility with older maven2 rpm
ln -s core.jar $RPM_BUILD_ROOT%{_javadir}/%{base_name}2/mavencore.jar

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/plugins/

# Install poms
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/poms
pushd %{base_name}2
    for project in \
            maven-artifact \
            maven-artifact-manager \
            maven-artifact-test \
            maven-core \
            maven-error-diagnostics \
            maven-model \
            maven-monitor \
            maven-plugin-api \
            maven-plugin-descriptor \
            maven-plugin-parameter-documenter \
            maven-plugin-registry \
            maven-profile \
            maven-project \
            maven-repository-metadata \
            maven-script \
            maven-settings; do

            artifactname=`echo $project | sed -e s:^maven-::g`
            cp $project/pom.xml $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/poms/JPP.%{base_name}2-$artifactname.pom

            # dependency fragments
            %add_to_maven_depmap org.apache.maven $project %{version} JPP/%{base_name}2 $artifactname

    done
    cp maven-script/maven-script-ant/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/poms/JPP.%{base_name}2-script-ant.pom
    cp maven-script/maven-script-beanshell/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/poms/JPP.%{base_name}2-script-beanshell.pom
    cp maven-reporting/maven-reporting-api/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/poms/JPP.%{base_name}2-reporting-api.pom
    cp pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/poms/JPP.%{base_name}2-maven.pom
popd

# The empty dependencies
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/poms
mkdir -p $RPM_BUILD_ROOT%{_javadir}/%{base_name}2
mkdir -p $RPM_BUILD_ROOT/usr/share/maven2/plugins
cp %{SOURCE7} $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/poms/JPP.maven2-empty-dep.pom
cp %{SOURCE8} $RPM_BUILD_ROOT%{_javadir}/%{base_name}2/empty-dep.jar

# For backwards compatibility
ln -s JPP.maven2-core.pom $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/poms/JPP.maven2-mavencore.pom

# jdom is needed by the new mapping system
ln -s %{_javadir}/jdom.jar $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/lib

# create appropriate links in /usr/share/java
ln -sf %{_datadir}/%{base_name}2/poms $RPM_BUILD_ROOT%{_javadir}/%{base_name}2
ln -sf %{_datadir}/%{base_name}2/plugins $RPM_BUILD_ROOT%{_javadir}/%{base_name}2

# Create repository links
ln -s %{_javadir} $RPM_BUILD_ROOT%{_datadir}/%{base_name}2/repository/JPP

%post
build-jar-repository -s -p %{_datadir}/%{base_name}2/core plexus/container-default plexus/utils
build-jar-repository -s -p %{_datadir}/%{base_name}2/core/boot classworlds

build-jar-repository -s -p %{_datadir}/%{base_name}2/lib \
    commons-cli \
    commons-lang \
    commons-logging \
    jsch \
    maven-doxia/sink-api \
    maven-wagon/file \
    maven-wagon/http-lightweight \
    maven-wagon/provider-api \
    maven-wagon/ssh \
    maven-wagon/ssh-external \
    plexus/interactivity-api

%update_maven_depmap


# We create links in %post in the dir's below. rm -rf them.
%preun -n %{name}
[ $1 = 0 ] || exit 0
rm -rf %{_datadir}/%{name}/lib/*

%postun
# FIXME: This doesn't always remove the plugins dir. It seems that rpm doesn't
# honour the Requires(postun) as it should, causing maven to get uninstalled 
# before some plugins are
if [ -d %{_javadir}/%{name} ] ; then rmdir --ignore-fail-on-non-empty %{_javadir}/%{name} >& /dev/null; fi
%update_maven_depmap

%files -n %{name}
%dir %{_datadir}/%{base_name}2
%{_datadir}/%{base_name}2/core
%{_datadir}/%{base_name}2/lib
%{_datadir}/%{base_name}2/poms
%{_datadir}/%{base_name}2/repository
%dir %{_datadir}/%{base_name}2/plugins
%{_mavendepmapfragdir}
%{_javadir}/%{base_name}2

%changelog
* Mon Sep 29 2008 Igor Vlasenko <viy@altlinux.ru> 0:2.0.7-alt3_3jpp5
- added /usr/share/maven2/plugins 

* Sat Sep 06 2008 Igor Vlasenko <viy@altlinux.ru> 0:2.0.7-alt2_3jpp5
- converted from JPackage by jppimport script

* Sat Jul 05 2008 Igor Vlasenko <viy@altlinux.ru> 0:2.0.7-alt1_3jpp5
- converted from JPackage by jppimport script

